<?php
        // Capçaleres per tal que funcioni l'API
        header("Access-Control-Allow-Origin: https://mobilitat.ricardcodina.cat");
        header("Access-Control-Allow-Origin: https://dev.mobilitat.ricardcodina.cat");
        header("Content-Type: application/json; charset=UTF-8");
        header("Access-Control-Allow-Methods: PUT");
        header("Access-Control-Max-Age: 3600");
        header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With");
        
        // Agafa l'objecte que genera l'API i les dades de la BD
        include_once '../config/database.php';
        include_once '../objects/parada.php';
        include_once '../objects/token.php';

        // Prepara la connexió a la base de dades
        $database = new Database();
        $db = $database->getConnection();

       // crea un nou objecte
        $avis = new Avis($db);

        // Agafem els valors rebut per POST
        $data = json_decode(file_get_contents("php://input"));


        //VERIFICACIÓ DEL TOKEN
        $token=isset($data->token) ? $data->token : "";
        $token = new Token($token);

        if ($token->comprova()){ //SI TOKEN CORRECTE, podem continuar
            if(
                !empty($data->dadesAvis->id) &&
                !empty($data->dadesAvis->tipusObjecte) &&
                !empty($data->dadesAvis->idObjecte) &&
                !empty($data->dadesAvis->tipusAvis) &&
                !empty($data->dadesAvis->titol)//Comprovem que s'han passat les dades obligatòries
            ){
    
                $data->dadesAvis->dataInici = !empty($data->dadesAvis->dataInici) ? date("Y-m-d", strtotime($data->dadesAvis->dataInici)) : date("Y-m-d"); //Les dades opcionals 
                $data->dadesAvis->dataFinal = !empty($data->dadesAvis->dataFinal) ? date("Y-m-d", strtotime($data->dadesAvis->dataFinal)) : NULL; 
                $data->dadesAvis->text = !empty($data->dadesAvis->text) ? $data->dadesAvis->text : NULL; 
    
                //Assignem els valors a les variables de l'objecte
                $avis->id = $data->dadesAvis->id;
                $avis->tipusObjecte = $data->dadesAvis->tipusObjecte;
                $avis->objecte = $data->dadesAvis->idObjecte;
                $avis->tipusAvis = $data->dadesAvis->tipusAvis;
                $avis->dataInici = $data->dadesAvis->dataInici;
                $avis->dataFinal = $data->dadesAvis->dataFinal;
                $avis->titol = $data->dadesAvis->titol;
                $avis->text = $data->dadesAvis->text;

    
    
                if($avis->modificar()) { //Cridem la funció de modificar (retorna true-false)
                    
                    // Si ha anat bé, retornem el codi 201 i avisem a l'usuari que ha anat bé
                    http_response_code(201);
                    echo json_encode(array("missatge" => "Avis modificat correctament"));
                }
    
                // Si ha fallat, retornem l'avis 503 i un missatge
                else {
    
                    http_response_code(503);
                    echo json_encode(array("missatge" => "No ha sigut possible modificar l'avis"));
                }
            } else {
            
                // Si falten dades, retornem l'error 400 i un missatge
                http_response_code(400);
                echo json_encode(array("missatge" => "Falten dades per poder modificar l'avis"));
            }     
        }

        else { //TOKEN NO VÀLID
            http_response_code(401);
            echo json_encode(array("missatge" => "Token incorrecte o sessió expirada"));
        }

?>