<?php
// Capçaleres per tal que funcioni l'API
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: access");
header("Access-Control-Allow-Methods: GET");
header("Access-Control-Allow-Credentials: true");
header('Content-Type: application/json');
 
// Agafa l'objecte que genera l'API i les dades de la BD
include_once '../config/database.php';
include_once '../objects/avis.php';


// Prepara la connexió a la base de dades
$database = new Database();
$db = $database->getConnection();

// crea un nou objecte
$avis = new Avis($db);


$arrayTipusAvis=$avis->obteTipusAvisos();


if(count($arrayTipusAvis)>0){
    $resposta=array();
    foreach ($arrayTipusAvis as $tipusAvis) {
        array_push($resposta, $tipusAvis);

    }

    // Si ha funcionat bé, enviarem el codi 200 (OK) i codifiquem la sortida en JSON
    http_response_code(200);
    echo json_encode($resposta);
}
 
else {
    // Si no ha anat bé retorna un missatge d'error
    http_response_code(400);
    echo json_encode(array("status"=>"ERROR", "message" => "No hi ha avisos vigents en aquests moments"));
}




?>