<?php
    // Capçaleres per tal que funcioni l'API
    header("Access-Control-Allow-Origin: https://mobilitat.ricardcodina.cat");
    header("Access-Control-Allow-Origin: https://dev.mobilitat.ricardcodina.cat");
    header("Content-Type: application/json; charset=UTF-8");
    header("Access-Control-Allow-Methods: POST");
    header("Access-Control-Max-Age: 3600");
    header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With");
    
    // Agafa l'objecte que genera l'API i les dades de la BD
    include_once '../config/database.php';
    include_once '../objects/avisUsuari.php';

    // Prepara la connexió a la base de dades
    $database = new Database();
    $db = $database->getConnection();

    // crea un nou objecte
    $avisUsuari = new AvisUsuari($db);

    // Agafem els valors rebut per POST
    $data = json_decode(file_get_contents("php://input"));

    if(
        !empty($data->dadesAvis->idExpedicio) &&
        !empty($data->dadesAvis->idParada) &&
        !empty($data->dadesAvis->tipusAvis)  //Comprovem que s'han passat les dades obligatòries
    ){

        !empty($data->dadesAvis->retard) ? $data->dadesAvis->retard : NULL; //Les dades opcionals 

        //Assignem els valors a les variables de l'objecte
        $avisUsuari->idExpedicio = $data->dadesAvis->idExpedicio;
        $avisUsuari->idParada = $data->dadesAvis->idParada;
        $avisUsuari->tipusAvis = $data->dadesAvis->tipusAvis;
        $avisUsuari->retard = $data->dadesAvis->retard;


        if($avisUsuari->afegir()) { //Cridem la funció d'afegir (retorna true-false)
        
            // Si ha anat bé, retornem el codi 201 i avisem a l'usuari que ha anat bé
            http_response_code(201);
            echo json_encode(array("missatge" => "Avís afegit correctament"));
        }

        // Si ha fallat, retornem l'avis 503 i un missatge
        else {

            http_response_code(503);
            echo json_encode(array("missatge" => "No ha sigut possible afegir l'avís"));
        }
    } else {
    
        // Si falten dades, retornem l'error 400 i un missatge
        http_response_code(400);
        echo json_encode(array("missatge" => "Falten dades per poder afegir l'avís"));
    }
?>