<?php
// Capçaleres per tal que funcioni l'API
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: access");
header("Access-Control-Allow-Methods: GET");
header("Access-Control-Allow-Credentials: true");
header('Content-Type: application/json');

// Agafa l'objecte que genera l'API i les dades de la BD
include_once '../config/database.php';
include_once '../objects/avisUsuari.php';


// Prepara la connexió a la base de dades
$database = new Database();
$db = $database->getConnection();

// crea un nou objecte
$avisUsuari = new AvisUsuari($db);

// Agafa l'ID de la linia i els resultats sol·licitats a partir del rebut a través del GET (.php?id=...)
$avisUsuari->idExpedicio = isset($_GET['idExpedicio']) ? $_GET['idExpedicio'] : null;

// Crida la funció de l'objecte
$avisUsuari->idExpedicio ? $arrayAvisos=$avisUsuari->obteAvisosExpedicio() : $arrayAvisos=$avisUsuari->obteTots();


if(count($arrayAvisos)>0){
    $respostaAvisos=array();

    foreach ($arrayAvisos as $avis) {
        $avis_item = array(
            "id" => $avis->id,
            "tipusAvis" => $avis->tipusAvis,
            "parada" => array( 
                "id" => $avis->parada->id,
                "nom" => $avis->parada->nom
            ),
            "expedicio" => array(
                "id" => $avis->expedicio->id,
                "linia" =>  array(
                    "codi" => $avis->expedicio->linia->codi,
                    "nom" => $avis->expedicio->linia->nom,
                    "sigles" => $avis->expedicio->linia->sigles,
                    "color" => $avis->expedicio->linia->color,
                    "transport_demanda" => $avis->expedicio->linia->transport_demanda),
                "paradaInici" => array(
                    "id" => $avis->expedicio->paradaInici->id,
                    "nom" =>  $avis->expedicio->paradaInici->nom,
                    "hora" => $avis->expedicio->trobaHoraPas($avis->expedicio->paradaInici)      
                ),
                "paradaFinal" => array(
                    "id" => $avis->expedicio->paradaFinal->id,
                    "nom" =>  $avis->expedicio->paradaFinal->nom,
                    "hora" => $avis->expedicio->trobaHoraPas($avis->expedicio->paradaFinal)           
                ),
            ),
            "retard" => $avis->retard,
            "dia" => $avis->data,
            "hora" => $avis->hora
        );

        array_push($respostaAvisos,$avis_item);
    }

    
    //Posem l'array generada dins d'un altre array
    $resposta["llista_avisos"] = $respostaAvisos;

    // Si ha funcionat bé, enviarem el codi 200 (OK) i codifiquem la sortida en JSON
    http_response_code(200);
    $resposta["status"] = "OK";
    echo json_encode($resposta);
}
 
else{
    // Si no ha anat bé retorna un missatge d'error
    http_response_code(200);
    echo json_encode(array("status"=>"ERROR", "message" => "No hi ha avisos."));
}




?>