<?php
    // Capçaleres per tal que funcioni l'API
    header("Access-Control-Allow-Origin: *");
    header("Access-Control-Allow-Headers: access");
    header("Access-Control-Allow-Methods: GET");
    header("Access-Control-Allow-Credentials: true");
    header('Content-Type: application/json');

    // Agafa l'objecte que genera l'API i les dades de la BD
    include_once '../config/database.php';
    include_once '../objects/avisUsuari.php';
    include_once '../objects/parada.php';
    include_once '../objects/linia.php';
    include_once '../objects/avis.php';
    include_once '../objects/expedicio.php';
    include_once '../objects/avisUsuari.php';

    // Prepara la connexió a la base de dades
    $database = new Database();
    $db = $database->getConnection();

    // crea un nou objecte
    $parada = new Parada($db);
    $avisUsuari = new AvisUsuari($db);
    $linia = new Linia($db);
    $expedicio = new Expedicio($db);
    $avis = new Avis($db);
    $avisUsuari = new AvisUsuari($db);

    // Crida la funció de l'objecte
    // Consultem quants objectes haurem de generar
    $arrayParades = $parada->obteTotes("ordre");
    $arrayLinies = $linia->obteTotes();
    $arrayExpedicions = $expedicio->obteTotes();
    $arrayAvisos=$avis->obteTotsAvisos();
    $arrayAvisosUsuari=$avisUsuari->obteTots();

    if($arrayParades&&$arrayLinies&&$arrayExpedicions&&$arrayAvisos&&$arrayAvisosUsuari){
        $resposta=array(
            "parada" => array(
                "numTotal" =>count($arrayParades)
            ),
            "linia" => array (
                "numTotal" => count($arrayLinies)
            ),
            "expedicio"=> array(
                "numTotal" => count($arrayExpedicions)
            ),
            "avis" => array (
                "numTotal" => count($arrayAvisos)
            ),
            "avisUsuari" => array (
                "numTotal" => count($arrayAvisosUsuari),
                "ultimsAvisos" => arrayUltimsAvisos($arrayAvisosUsuari)
            )
        );

       

        // Si ha funcionat bé, enviarem el codi 200 (OK) i codifiquem la sortida en JSON
        http_response_code(200);
        echo json_encode($resposta);
    }
    
    else{
        // Si no ha anat bé retorna un missatge d'error
        http_response_code(404);
        echo json_encode(array("status"=>"ERROR", "message" => "No s'han carregat les estadístiques"));
    }


    function arrayUltimsAvisos($arrayAvisosUsuari) {

        $arrayUltimsAvisos = array_slice($arrayAvisosUsuari, 0, 10);

        $respostaAvisos=array();

        foreach ($arrayUltimsAvisos as $avis) {
            $avis_item = array(
                "id" => $avis->id,
                "tipusAvis" => $avis->tipusAvis,
                "parada" => array( 
                    "id" => $avis->parada->id,
                    "nom" => $avis->parada->nom
                ),
                "expedicio" => array(
                    "id" => $avis->expedicio->id
                ),
                "retard" => $avis->retard,
                "dia" => $avis->data,
                "hora" => $avis->hora
            );

            array_push($respostaAvisos,$avis_item);
        }

        return $respostaAvisos;


    }

?>