<?php
        // Capçaleres per tal que funcioni l'API
        header("Access-Control-Allow-Origin: https://mobilitat.ricardcodina.cat");
        header("Access-Control-Allow-Origin: https://dev.mobilitat.ricardcodina.cat");
        header("Content-Type: application/json; charset=UTF-8");
        header("Access-Control-Allow-Methods: POST");
        header("Access-Control-Max-Age: 3600");
        header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With");
        
        // Agafa l'objecte que genera l'API i les dades de la BD
        include_once '../config/database.php';
        include_once '../objects/linia.php';
        include_once '../objects/parada.php';
        include_once '../objects/expedicio.php';
        include_once '../objects/token.php';
        include_once '../funcions/funcions.php';

        // Prepara la connexió a la base de dades
        $database = new Database();
        $db = $database->getConnection();

        // crea un nou objecte
        $expedicio = new Expedicio($db);

        // Agafem els valors rebut per POST
        $data = json_decode(file_get_contents("php://input"));
        
        //Ordenem l'horari per hores
        $horari = $data->dades->horari;
        usort($horari, "compararHoraPas");

        //VERIFICACIÓ DEL TOKEN
        $token=isset($data->token) ? $data->token : "";
        $token = new Token($token);

        if ($token->comprova()){ //SI TOKEN CORRECTE, podem continuar
            if(
                !empty($data->dades->codiLinia) &&
                !empty($data->dades->horari)//Comprovem que s'han passat les dades obligatòries
            ){
    
                //Assignem els valors a les variables de l'objecte
                $expedicio->linia = new Linia($db);
                $expedicio->linia->codi = $data->dades->codiLinia;
                $expedicio->diesCirculacio=array(converteixANumeric($data->dades->festiu),converteixANumeric($data->dades->dilluns),converteixANumeric($data->dades->dimarts),converteixANumeric($data->dades->dimecres),converteixANumeric($data->dades->dijous),converteixANumeric($data->dades->divendres),converteixANumeric($data->dades->dissabte));
                $expedicio->diaInici = ($data->dades->dataInici!=null ? date("Y-m-d", strtotime($data->dades->dataInici)) : null);
                $expedicio->diaFinal = ($data->dades->dataFinal!=null ? date("Y-m-d", strtotime($data->dades->dataFinal)) : null);
    
                $expedicio->paradaInici = new Parada($db);
                $expedicio->paradaInici->id = $horari[0]->idParada;

                $expedicio->paradaFinal = new Parada($db);
                $expedicio->paradaFinal->id = $horari[count($horari)-1]->idParada;


    
                if($expedicio->afegir()&&$expedicio->afegirHorari($horari)) { //Cridem la funció d'afegir (retorna true-false)
                
                    // Si ha anat bé, retornem el codi 201 i avisem a l'usuari que ha anat bé
                    http_response_code(201);
                    echo json_encode(array("missatge" => "Expedició afegida correctament. El seu codi és el " . $expedicio->id));
                }
    
                // Si ha fallat, retornem l'avis 503 i un missatge
                else {
    
                    http_response_code(503);
                    echo json_encode(array("missatge" => "No ha sigut possible afegir l'expedició: error petició Base de Dades"));
                }
            } else {
            
                // Si falten dades, retornem l'error 400 i un missatge
                http_response_code(400);
                echo json_encode(array("missatge" => "No ha sigut possible afegir l'expedició: falten dades"));
            }     
        }

        else { //TOKEN NO VÀLID
            http_response_code(401);
            echo json_encode(array("missatge" => "Token incorrecte o sessió expirada"));
        }

?>