<?php
        // Capçaleres per tal que funcioni l'API
        header("Access-Control-Allow-Origin: https://mobilitat.ricardcodina.cat");
        header("Access-Control-Allow-Origin: https://dev.mobilitat.ricardcodina.cat");
        header("Content-Type: application/json; charset=UTF-8");
        header("Access-Control-Allow-Methods: PUT");
        header("Access-Control-Max-Age: 3600");
        header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With");
        
        // Agafa l'objecte que genera l'API i les dadesExpedicio de la BD
        include_once '../config/database.php';
        include_once '../objects/expedicio.php';
        include_once '../objects/token.php';
        include_once '../objects/linia.php';
        include_once '../objects/parada.php';
        include_once '../objects/expedicio.php';        
        include_once '../funcions/funcions.php';

        // Prepara la connexió a la base de dadesExpedicio
        $database = new Database();
        $db = $database->getConnection();

        // crea un nou objecte
        $expedicio = new Expedicio($db);

        // Agafem els valors rebut per POST
        $data = json_decode(file_get_contents("php://input"));

        //Ordenem l'horari per hores
        $horari = $data->dadesExpedicio->horari;
        usort($horari, "compararHoraPas");

        //VERIFICACIÓ DEL TOKEN
        $token=isset($data->token) ? $data->token : "";
        $token = new Token($token);

        if ($token->comprova()){ //SI TOKEN CORRECTE, podem continuar
            if(
                !empty($data->dadesExpedicio->id) &&
                !empty($data->dadesExpedicio->codiLinia) &&
                !empty($data->dadesExpedicio->horari)//Comprovem que s'han passat les dadesExpedicio obligatòries
            ){
    
                //Assignem els valors a les variables de l'objecte
                $expedicio->nom = $data->dadesExpedicio->id;

                $expedicio->linia = new Linia($db);
                $expedicio->linia->codi = $data->dadesExpedicio->codiLinia;
                $expedicio->diesCirculacio=array(converteixANumeric($data->dadesExpedicio->festiu),converteixANumeric($data->dadesExpedicio->dilluns),converteixANumeric($data->dadesExpedicio->dimarts),converteixANumeric($data->dadesExpedicio->dimecres),converteixANumeric($data->dadesExpedicio->dijous),converteixANumeric($data->dadesExpedicio->divendres),converteixANumeric($data->dadesExpedicio->dissabte));
                $expedicio->diaInici = ($data->dadesExpedicio->dataInici!=null ? date("Y-m-d", strtotime($data->dadesExpedicio->dataInici)) : null);
                $expedicio->diaFinal = ($data->dadesExpedicio->dataFinal!=null ? date("Y-m-d", strtotime($data->dadesExpedicio->dataFinal)) : null);
    
                $expedicio->paradaInici = new Parada($db);
                $expedicio->paradaInici->id = $horari[0]->idParada;

                $expedicio->paradaFinal = new Parada($db);
                $expedicio->paradaFinal->id = $horari[count($horari)-1]->idParada;
    
    
                if($expedicio->modificar()&&$expedicio->modificaHorari($horari)) { //Cridem la funció d'afegir (retorna true-false)
                
                    // Si ha anat bé, retornem el codi 201 i avisem a l'usuari que ha anat bé
                    http_response_code(201);
                    echo json_encode(array("missatge" => "Línia modificada correctament."));
                }
    
                // Si ha fallat, retornem l'avis 503 i un missatge
                else {
    
                    http_response_code(503);
                    echo json_encode(array("missatge" => "No ha sigut possible modificar la línia"));
                }
            } else {
            
                // Si falten dadesExpedicio, retornem l'error 400 i un missatge
                http_response_code(400);
                echo json_encode(array("missatge" => "No ha sigut possible modificar la línia"));
            }     
        }

        else { //TOKEN NO VÀLID
            http_response_code(401);
            echo json_encode(array("missatge" => "Token incorrecte o sessió expirada"));
        }


?>