<?php
// Capçaleres per tal que funcioni l'API
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: access");
header("Access-Control-Allow-Methods: GET");
header("Access-Control-Allow-Credentials: true");
header('Content-Type: application/json');
 
// Agafa l'objecte que genera l'API i les dades de la BD
include_once '../config/database.php';
include_once '../objects/expedicio.php';
include_once '../objects/linia.php';

// Prepara la connexió a la base de dades
$database = new Database();
$db = $database->getConnection();

// crea un nou objecte
$expedicio = new Expedicio($db);

// si es passa codi de linia es prepara l'objecte
$codiLinia = isset($_GET['codiLinia']) ? $_GET['codiLinia'] : null;
if (!is_null($codiLinia)) {
    $linia = new Linia($db);
    $linia->codi = $codiLinia;
    $linia->obteDades();
    $expedicio->linia=$linia;
}

// Consultem quants objectes haurem de generar
$arrayExpedicions = $expedicio->obteTotes();


// mirem que tinguem resultats
if(count($arrayExpedicions)>0){
    
    // preparem l'array de sortida
    $expedicio_arr=array();
    $expedicio_arr["llistat"]=array();
 
   // Generem cada item de l'array a partir dels resultats
   foreach ($arrayExpedicions as $expedicio) {
    
    $afegeixItem=true;
    $circulaAra=null;
    
    if (isset($_GET['circulaAra'])) { //Per discriminar quan només volem autobusos que circulin ara   
        $circulaAra=$expedicio->busCircula();
        is_null($circulaAra) && $afegeixItem=false;
    }
    
    $expedicio_item = array(
        "id" => $expedicio->id,
        "linia" =>  array(
            "codi" => $expedicio->linia->codi,
            "nom" => $expedicio->linia->nom,
            "sigles" => $expedicio->linia->sigles,
            "color" => $expedicio->linia->color,
            "transport_demanda" => $expedicio->linia->transport_demanda),
        "paradaInici" => array(
            "id" => $expedicio->paradaInici->id,
            "nom" =>  $expedicio->paradaInici->nom,
            "hora" => $expedicio->trobaHoraPas($expedicio->paradaInici)      
        ),
        "paradaFinal" => array(
            "id" => $expedicio->paradaFinal->id,
            "nom" =>  $expedicio->paradaFinal->nom,
            "hora" => $expedicio->trobaHoraPas($expedicio->paradaFinal)           
        ),
        "diesCirculacio" => array(
            "dilluns" => ($expedicio->diesCirculacio[1]==1 ? true : false),
            "dimarts" => ($expedicio->diesCirculacio[2]==1 ? true : false),
            "dimecres" => ($expedicio->diesCirculacio[3]==1 ? true : false),
            "dijous" => ($expedicio->diesCirculacio[4]==1 ? true : false),
            "divendres" => ($expedicio->diesCirculacio[5]==1 ? true : false),
            "dissabte" => ($expedicio->diesCirculacio[6]==1 ? true : false),
            "festiu" => ($expedicio->diesCirculacio[0]==1 ? true : false)
        ),
        "diesCirculacioArray" => $expedicio->diesCirculacio,
        "periode" => array(
            "inici" => $expedicio->diaInici,
            "final" => $expedicio->diaFinal
        ),
        "circula" => $expedicio->circulaPeriode(),
        "circulaAra" => $circulaAra,
        "polilinia_codificada" => $expedicio->obtePolilinia(),
        "numAvisosUsuari" => $expedicio->numAvisosUsuari()
        
    );
 
        $afegeixItem && array_push($expedicio_arr["llistat"], $expedicio_item);
    }
 
    // Si ha funcionat bé, enviarem el codi 200 (OK) i codifiquem la sortida en JSON
    http_response_code(200);
    echo json_encode($expedicio_arr);
    
}
 
    else {
    
        // Si no ha anat bé retorna el codi 404 i un missatge d'error
        http_response_code(404);
        echo json_encode(
            array("message" => "No s'han trobat expedicions.")
        );
    }


?>