<?php
//API GENERA ITINERARI
    //Passos per calcular l'itinerari
    //1. Mirar si origen és parada o coordenades.
    //2. Si és coordenades, buscar quina és 


// Capçaleres per tal que funcioni l'API
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: access");
header("Access-Control-Allow-Methods: GET");
header("Access-Control-Allow-Credentials: true");
header('Content-Type: application/json');
 
// Agafa l'objecte que genera l'API i les dades de la BD
include_once '../config/database.php';
include_once '../objects/lloc.php';
include_once '../objects/parada.php';
include_once '../objects/itinerari.php';
include_once '../funcions/googleAPI.php'; //Inclou les funcions d'itinerari de Google Maps

// Prepara la connexió a la base de dades
$database = new Database();
$db = $database->getConnection();

//Variables que rebem per generar l'itinerari

$origenData=isset($_GET['origen']) ? $_GET['origen'] : "Institut Guillem de Berguedà";
$destinacioData=isset($_GET['destinacio']) ? $_GET['destinacio'] : "Ajuntament de Gironella";
$data=isset($_GET['data']) ? $_GET['data'] : date("d-m-Y");
$hora=isset($_GET['hora']) ? $_GET['hora'] : date("H:i");
$limitResultats = isset($_GET['limitResultats']) ? $_GET['limitResultats'] : 4;



//Creem la parada d'origen i destinacio
$paradaOrigen = new Parada($db);
$paradaDestinacio = new Parada($db);

//Buscar si el nom rebut correspon amb una parada ja establerta
//++++ TO DO ++++
$paradaOrigen->nom = $origenData;


//Creem els llocs d'origen i destinacio
//L'objecte ja s'encarrega d'obtenir les dades de Google Maps
$origen = new Lloc($origenData);
$destinacio = new Lloc($destinacioData);






//Busca la parada més pròxima a partir dels punts d'inici i destinació
$paradaOrigen -> assignarParadaProxima($origen->getLatitud(),$origen->getLongitud());
$paradaDestinacio -> assignarParadaProxima($destinacio->getLatitud(),$destinacio->getLongitud());

if (!empty($paradaOrigen->id)&&!empty($paradaDestinacio->id)) { //Si s'han obtingut totes les dades anterior, es continua.
    //Creem l'objecte itinerari que genera els recorreguts possibles
    $itinerari = new Itinerari($db, $paradaOrigen, $paradaDestinacio, $data, $hora, $limitResultats);
    $resultatItineraris=$itinerari->calculaItinerari();
    //echo $resultatItineraris;

    // preparem l'array de sortida
    $resposta=array();
    $resposta["dadesItinerari"]=array(
        "origen" => array (
            "nom" => $origen->nom,
            "adreça" =>$origen->adress,
            "latitud" => $origen->getLatitud(),
            "longitud" => $origen->getLongitud()
            
        ),
        "destinacio" => array (
            "nom" => $destinacio->nom,
            "adreça" =>$destinacio->adress,
            "latitud" => $destinacio->getLatitud(),
            "longitud" => $destinacio->getLongitud()
            
        ),
        "data" => $data,
        "hora" => $hora,
        "paradaOrigen" => array(
            "id" => $paradaOrigen->id,
            "nom" => $paradaOrigen->nom,
            "latitud" => $paradaOrigen->latitud,
            "longitud" => $paradaOrigen->longitud
        ),
        "paradaDestinacio" => array(
            "id" => $paradaDestinacio->id,
            "nom" => $paradaDestinacio->nom,
            "latitud" => $paradaDestinacio->latitud,
            "longitud" => $paradaDestinacio->longitud
        )
    );


    //Generem itinerari a peu des de l'origen a parada i s'assigna a la resposta
    $resposta["itinerariAParadaOrigen"]=generaItinerariAPeu($origen->getLatitud(), $origen->getLongitud(), $paradaOrigen->latitud, $paradaOrigen->longitud);

    $resposta["itineraris"]=$resultatItineraris;

    //Generem itinerari a peu des de la destinació a parada i s'assigna a la resposta
    $resposta["itinerariDesParadaDestinacio"]=generaItinerariAPeu($paradaDestinacio->latitud, $paradaDestinacio->longitud,$destinacio->getLatitud(), $destinacio->getLongitud());

    // Si ha funcionat bé, enviarem el codi 200 (OK) i codifiquem la sortida en JSON
    http_response_code(200);
    echo json_encode($resposta);
} else {
    http_response_code(404);
    echo json_encode(array("missatge" => "No s'han trobat parades properes als punts introduits"));
}


?>