<?php
// Capçaleres per tal que funcioni l'API
header("Access-Control-Allow-Origin: *");
header("Content-Type: application/json; charset=UTF-8");
 
// Agafa l'objecte que genera l'API i les dades de la BD
include_once '../config/database.php';
include_once '../objects/linia.php';
 
// Prepara la connexió a la base de dades
$database = new Database();
$db = $database->getConnection();
 
// crea un nou objecte
$linia = new Linia($db);
 
// Consultem quants objectes haurem de generar
$arrayLinies = $linia->obteTotes();

// mirem que tinguem resultats
if(count($arrayLinies)>0){
    
    // preparem l'array de sortida
    $arr=array();
    $arr["llistat"]=array();
 
    // Generem cada item de l'array a partir dels resultats
    foreach ($arrayLinies as $linia) {
        
        //Preparem un array amb l'ID de les parades
        $arrayParades=$linia->obteParades();
        $arrayIDParades=array();

        foreach ($arrayParades as $parada){
            $item=array(
                "id"=>$parada->id,
                "nom"=>$parada->nom
            );
            array_push($arrayIDParades, $item);
        }
        
        $item=array(
            "codi" => $linia->codi,
            "nom" => $linia->nom,
            "sigles" => $linia->sigles,
            "color" => $linia->color,
            "transport_demanda" => $linia->transport_demanda,
            "polilinia_codificada" => $linia->obtePolilinia(),
            "parades" => $arrayIDParades,
            "visible" => true         
        );
 
        array_push($arr["llistat"], $item);
    }
 
    // Si ha funcionat bé, enviarem el codi 200 (OK) i codifiquem la sortida en JSON
    http_response_code(200);
    $arr["status"]="OK";
    echo json_encode($arr);
    
}
 
    else {
    
        // Si no ha anat bé retorna el codi 404 i un missatge d'error
        http_response_code(404);
        echo json_encode(
            array("status"=> "ERROR", "message" => "No s'han trobat resultats.")
        );
    }

    ?>