<?php

        // Capçaleres per tal que funcioni l'API
        header("Access-Control-Allow-Origin: https://mobilitat.ricardcodina.cat");
        header("Access-Control-Allow-Origin: https://dev.mobilitat.ricardcodina.cat");
        header("Content-Type: application/json; charset=UTF-8");
        header("Access-Control-Allow-Methods: POST");
        header("Access-Control-Max-Age: 3600");
        header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With");
        
        // Agafa l'objecte que genera l'API i les dades de la BD
        include_once '../config/database.php';
        include_once '../objects/parada.php';
        include_once '../objects/token.php';

        // Prepara la connexió a la base de dades
        $database = new Database();
        $db = $database->getConnection();

        // crea un nou objecte
        $parada = new Parada($db);

        // Agafem els valors rebut per POST
        $data = json_decode(file_get_contents("php://input"));


        //VERIFICACIÓ DEL TOKEN
        $token=isset($data->token) ? $data->token : "";
        $token = new Token($token);

        if ($token->comprova()){ //SI TOKEN CORRECTE, podem continuar
            if(
                !empty($data->dadesParada->nom) &&
                !empty($data->dadesParada->longitud) &&
                !empty($data->dadesParada->latitud)//Comprovem que s'han passat les dades obligatòries
            ){
    
                !empty($data->dadesParada->observacions) ? $data->dadesParada->observacions : NULL; //Les dades opcionals 
    
                //Assignem els valors a les variables de l'objecte
                $parada->nom = $data->dadesParada->nom;
                $parada->latitud = $data->dadesParada->latitud;
                $parada->longitud = $data->dadesParada->longitud;
                $parada->observacions = $data->dadesParada->observacions;

                //Carreguem el valor del codi postal aprofitant l'API de Google Maps
                $parada->trobaCodiPostal();
    
    
                if($parada->afegir()) { //Cridem la funció d'afegir (retorna true-false)
                    
                    // Si ha anat bé, retornem el codi 201 i avisem a l'usuari que ha anat bé
                    http_response_code(201);
                    echo json_encode(array("missatge" => "Parada afegida correctament"));
                }
    
                // Si ha fallat, retornem l'avis 503 i un missatge
                else {
    
                    http_response_code(503);
                    echo json_encode(array("missatge" => "No ha sigut possible afegir la parada"));
                }
            } else {
            
                // Si falten dades, retornem l'error 400 i un missatge
                http_response_code(400);
                echo json_encode(array("missatge" => "Falten dades per poder afegir la parada"));
            }     
        }

        else { //TOKEN NO VÀLID
            http_response_code(401);
            echo json_encode(array("missatge" => "Token incorrecte o sessió expirada"));
        }
?>