<?php
// Capçaleres per tal que funcioni l'API
header("Access-Control-Allow-Origin: *");
header("Content-Type: application/json; charset=UTF-8");
 
// Agafa l'objecte que genera l'API i les dades de la BD
include_once '../config/database.php';
include_once '../objects/parada.php';
 
// Prepara la connexió a la base de dades
$database = new Database();
$db = $database->getConnection();
 
// crea un nou objecte
$parada = new Parada($db);
$ordre = isset($_GET['ordre']) ? $_GET['ordre'] : "ordre"; //si rebem ordre ordena per ordre, si no per berguedà i ordre alfabètic
$limit = isset($_GET['limit']) ? $_GET['limit'] : null; //si rebem limit, tindrem el limit de parades rebut

// Consultem quants objectes haurem de generar
$arrayParades = $parada->obteTotes($ordre, $limit);

// mirem que tinguem resultats
if(count($arrayParades)>0){
    
    // preparem l'array de sortida
    $parada_arr=array();
    $parada_arr["llistat"]=array();
 
   // Generem cada item de l'array a partir dels resultats
   foreach ($arrayParades as $parada) {
    
        $parada_item=array(
            "id" => $parada->id,
            "nom" => $parada->nom,
            "latitud" => $parada->latitud,
            "longitud" => $parada->longitud,
            "observacions" => html_entity_decode($parada->observacions),            
            "poblacio" => $parada->poblacio,
            "codiPostal" => $parada->codiPostal,
            "esBergueda" => $parada->esBergueda,
            "visible" => true
            
        );
 
        array_push($parada_arr["llistat"], $parada_item);
    }
 
    // Si ha funcionat bé, enviarem el codi 200 (OK) i codifiquem la sortida en JSON
    http_response_code(200);
    echo json_encode($parada_arr);
    
}
 
    else {
    
        // Si no ha anat bé retorna el codi 404 i un missatge d'error
        http_response_code(404);
        echo json_encode(
            array("message" => "No s'han trobat parades.")
        );
    }

    ?>