<?php

//POST Afegir USUARI
//Passar dades en JSON amb aquest format:

    // {
    //     "nom" : "Ricard Codina",
    //     "email" : "ricardcodina@uoc.edu",
    //     "contrasenya" : "//CONTRASENYA//"
    // }

// Capçaleres per tal que funcioni l'API
header("Access-Control-Allow-Origin: *");
header("Content-Type: application/json; charset=UTF-8");
header("Access-Control-Allow-Methods: POST");
header("Access-Control-Max-Age: 3600");
header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With");

// Agafa l'objecte que genera l'API i les dades de la BD
include_once '../config/database.php';
include_once '../objects/usuari.php';

// Prepara la connexió a la base de dades
$database = new Database();
$db = $database->getConnection();

// crea un nou objecte Usuari
$usuari = new Usuari($db);

// Agafem els valors rebut per POST
$data = json_decode(file_get_contents("php://input"));

// Assignem cada valor rebut amb la propietat de l'objecte


$usuari->nom = $data->nom;
$usuari->email = $data->email;
$usuari->contrasenya = $data->contrasenya;


    // Intentem crear l'usuari
    if(
        !empty($usuari->nom) && //Mirem que s'han passat totes les dades
        !empty($usuari->email) &&
        !empty($usuari->contrasenya) &&
        $usuari->crear() //Retornarà true o false, segons si l'acció ha anat bé
    ){
    
        // Codi satisfactori
        http_response_code(200);
    
        // Missatge positiu
        echo json_encode(array("missatge" => "L'usuari s'ha creat correctament"));
    }
    
    // Si no ha anat bé
    else{
    
        // Codi HTTP d'error
        http_response_code(400);
    
        // Missatge d'error
        echo json_encode(array("missatge" => "No ha sigut possible crear un nou usuari"));
    }
?>