<?php

//POST Comprovar TOKEN
//Passar dades en JSON amb aquest format:

    // {
    //     "token" : "//TOKEN//",
    // }

// Capçaleres per tal que funcioni l'API
header("Access-Control-Allow-Origin: *");
header("Content-Type: application/json; charset=UTF-8");
header("Access-Control-Allow-Methods: POST");
header("Access-Control-Max-Age: 3600");
header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With");

// arxius per comprovar el token de l'API
include_once '../config/core.php';
include_once '../libs/php-jwt-master/src/BeforeValidException.php';
include_once '../libs/php-jwt-master/src/ExpiredException.php';
include_once '../libs/php-jwt-master/src/SignatureInvalidException.php';
include_once '../libs/php-jwt-master/src/JWT.php';
use \Firebase\JWT\JWT;

// agafem el token permès
$data = json_decode(file_get_contents("php://input"));
 
// si existeix l'assignem a la variable, si no, ho deixem en blanc
$jwt=isset($data->token) ? $data->token : "";
 
// si el token no és buit
if($jwt){
 
    // si el token és correcte, mostrarem les dades de l'usuari
    try {
        // descodifiquem el token
        $decoded = JWT::decode($jwt, $key, array('HS256'));
 
        // assignem codi de resposta HTTP positiu
        http_response_code(200);
 
        // mostrem les dades d'usuari
        echo json_encode(array(
            "missatge" => "Accés permès",
            "data" => $decoded->data
        ));
 
    }
 
        // Si dóna error, és que el token és incorrecte
    catch (Exception $e){
    
        // enviem missatge d'error
        http_response_code(401);
    
        // Avisem a l'usuari que no ha anat bé i mostrem el missatge d'error
        echo json_encode(array(
            "missatge" => "Accés denegat",
            "error" => $e->getMessage()
        ));
    }
} else { //Si no s'ha passat token.
 
    // donem missatge d'error
    http_response_code(401);
 
    // enviem un missatge d'error
    echo json_encode(array("missatge" => "Falta introduir un token"));
}
?>
