<?php
    // arxius per generar el token de l'API
    include_once '../config/core.php';
    include_once '../libs/php-jwt-master/src/BeforeValidException.php';
    include_once '../libs/php-jwt-master/src/ExpiredException.php';
    include_once '../libs/php-jwt-master/src/SignatureInvalidException.php';
    include_once '../libs/php-jwt-master/src/JWT.php';
    use \Firebase\JWT\JWT;

if ($_SERVER['REQUEST_METHOD'] == 'OPTIONS') { //Per fer una crida a una API des d'un domini extern, hem de respondre primer afirmativament a una petició OPTIONS https://es.stackoverflow.com/questions/218426/falta-la-cabecera-cors-access-control-allow-origin
    // Indica els mètodes permesos
    header('Access-Control-Allow-Methods: POST');
    // Indica les capçaleres permeses
    header("Access-Control-Allow-Origin: https://mobilitat.ricardcodina.cat");
        header("Access-Control-Allow-Origin: https://dev.mobilitat.ricardcodina.cat");
    header('Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With');
    http_response_code(204);
    
} else {

    //POST Verifica USUARI
    //Passar dades en JSON amb aquest format:

        // {
        //     "email" : "ricardcodina@uoc.edu",
        //     "contrasenya" : "//CONTRASENYA//"
        // }

    // Capçaleres per tal que funcioni l'API
    header("Access-Control-Allow-Origin: *");
    header("Content-Type: application/json; charset=UTF-8");
    header("Access-Control-Allow-Methods: POST");
    header("Access-Control-Max-Age: 3600");
    header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With");

    // Agafa l'objecte que genera l'API i les dades de la BD
    include_once '../config/database.php';
    include_once '../objects/usuari.php';

    // Prepara la connexió a la base de dades
    $database = new Database();
    $db = $database->getConnection();

    // crea un nou objecte Usuari
    $usuari = new Usuari($db);

    // Agafem els valors rebut per POST
    $data = json_decode(file_get_contents("php://input"));

    // assignem el valor de correu electrònic rebut i mirem si està a la base de dades
    $usuari->email = $data->email;
    $existeixEmail = $usuari->existeixUsuari();

        // mirem si la contrasenya correspon. Amb password_verify, ja sap quin mètode de codificació es va fer servir
        if($existeixEmail && password_verify($data->contrasenya, $usuari->contrasenya)){
            //Preparem l'array pel Token
            $token = array(
                "iss" => $iss,
                "aud" => $aud,
                "iat" => $iat,
                "nbf" => $nbf,
                "exp" => $exp,
                "data" => array(
                    "id" => $usuari->id,
                    "nom" => $usuari->nom,
                    "email" => $usuari->email
                )
            );
        
            // assignem el codi de resposta
            http_response_code(200);
        
            // generem el token 
            $jwt = JWT::encode($token, $key);

            echo json_encode(
                    array(
                        "missatge" => "Entrada correcta",
                        "token" => $jwt
                    )
                );
        
        }
        // login failed
        else{
        
            // set response code
            http_response_code(401);
        
            // tell the user login failed
            echo json_encode(array("missatge" => "L'usuari o la contrasenya són incorrectes"));
        }
    } 
    ?>