<?php
// Capçaleres per tal que funcioni l'API
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: access");
header("Access-Control-Allow-Methods: GET");
header("Access-Control-Allow-Credentials: true");
header('Content-Type: application/json');
 
// Agafa l'objecte que genera l'API i les dades de la BD
include_once '../config/database.php';
include_once '../objects/linia.php';


// Prepara la connexió a la base de dades
$database = new Database();
$db = $database->getConnection();

// crea un nou objecte
$linia = new Linia($db);


// Agafa l'ID de la linia i els resultats sol·licitats a partir del rebut a través del GET (.php?id=...)
$linia->codi = isset($_GET['codi']) ? $_GET['codi'] : 0;
$ordre=isset($_GET['ordre']) ? $_GET['ordre'] : "DESC"; //Mirem quin ordre volem generar
$diaSetmana=isset($_GET['diaSetmana']) ? $_GET['diaSetmana'] : "dilluns"; //Mirem quin dia volem generar

// Crida la funció de l'objecte
$linia->obteDades();


if($linia->nom!=null){

    $expedicionsLinia=$linia->obteExpedicionsPerDia($diaSetmana);
    $paradesLinia=$linia->obteParades();
        

       
            $arrayResposta= array();
            //FEM UNA ARRAY DIFERENT SEGONS L'ORDRE SOL·LICITAT
                if ($ordre=="DESC") {
                    foreach ($paradesLinia as $parada) {
                        $arrayParada=array();
                        $arrayExpedicionsID=array();
                        $totalExpedicions=0; //Serveix per saber quants serveis troba que compleixin els requisits
                        array_push($arrayParada, $parada->nom);
                        foreach ($expedicionsLinia as $expedicio) {            
                                if ($expedicio->invers=="DESC") {
                                    $horaPas=$expedicio->trobaHoraPas($parada);
                                    array_push($arrayParada, $horaPas);
                                    $totalExpedicions++;
                                    array_push($arrayExpedicionsID,$expedicio->id);

                                }
                        }
                        array_push($arrayResposta,$arrayParada);
                    }
                    $arrayResposta=array_reverse($arrayResposta); //Fem reverse dos cops per col·locar la llista d'ID en primer lloc
                    array_push($arrayResposta,$arrayExpedicionsID);
                    $arrayResposta=array_reverse($arrayResposta);
                }
                
                if ($ordre=="ASC") {
                    foreach ($paradesLinia as $parada) {
                        $totalExpedicions=0; //Serveix per saber quants serveis troba que compleixin els requisits
                        $arrayParada=array();
                        $arrayExpedicionsID=array();
                        array_push($arrayParada, $parada->nom);
                        foreach ($expedicionsLinia as $expedicio) {            
                                if ($expedicio->invers=="ASC") {
                                    $horaPas=$expedicio->trobaHoraPas($parada);
                                    array_push($arrayParada, $horaPas);
                                    $totalExpedicions++;
                                    array_push($arrayExpedicionsID,$expedicio->id);
                                }
                        }
                        array_push($arrayResposta,$arrayParada);
                    }
                    array_push($arrayResposta,$arrayExpedicionsID);
                    $arrayResposta=array_reverse($arrayResposta); //Girem l'ordre de la taula (parades i horari)
                }

            if ($totalExpedicions>0) {   
                $resposta["expedicions"] = $arrayResposta;
                // Si ha funcionat bé, enviarem el codi 200 (OK) i codifiquem la sortida en JSON
                http_response_code(200);
                $resposta["status"] = "OK";
                $resposta["missatge"] = "OK";
                echo json_encode($resposta);
            } else {
                http_response_code(200);
                echo json_encode(array("status"=>"ERROR", "missatge" => "No s'han trobat serveis per la direcció i dia seleccionats."));    
            }
        
    }
 
else{
    // Si no ha anat bé retorna un missatge d'error
    http_response_code(200);
    echo json_encode(array("status"=>"ERROR", "missatge" => "No existeix aquesta línia."));
}







?>