<?php
// Capçaleres per tal que funcioni l'API
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: access");
header("Access-Control-Allow-Methods: GET");
header("Access-Control-Allow-Credentials: true");
header('Content-Type: application/json');
 
// Agafa l'objecte que genera l'API i les dades de la BD
include_once '../config/database.php';
include_once '../objects/linia.php';


// Prepara la connexió a la base de dades
$database = new Database();
$db = $database->getConnection();

// crea un nou objecte
$linia = new Linia($db);


// Agafa l'ID de la linia i els resultats sol·licitats a partir del rebut a través del GET (.php?id=...)
$linia->codi = isset($_GET['codi']) ? $_GET['codi'] : 0;

// Crida la funció de l'objecte
$linia->obteDades();


if($linia->nom!=null){


    //Obtenim dades de la parada concreta
    $resposta=array();
    // Fem una array per emmagatzemar les dades rebudes
    $linia_item = array(
        "codi" => $linia->codi,
        "nom" => $linia->nom,
        "sigles" => $linia->sigles,
        "color" => $linia->color,
        "transport_demanda" => $linia->transport_demanda    
 
    );
    
    //Posem l'array generada dins d'un altre array
    $resposta["info_linia"] = $linia_item;

    $parades=$linia->obteParades();
    $resposta["parades"] = generaArrayParades($parades);

    $resposta["polilinia_codificada"] = $linia->obtePolilinia();

    $resposta["avisos"]=$linia->obteAvisos();

    // Si ha funcionat bé, enviarem el codi 200 (OK) i codifiquem la sortida en JSON
    http_response_code(200);
    $resposta["status"] = "OK";
    echo json_encode($resposta);
}
 
else{
    // Si no ha anat bé retorna un missatge d'error
    http_response_code(200);
    echo json_encode(array("status"=>"ERROR", "message" => "No existeix aquesta línia."));
}



function generaArrayParades($parades){
    $arrayParades=array();
    //PREPAREM ARRAY AMB EXPEDICIONS
    if (count($parades)>0) {
        $i=0;
        foreach ($parades as $parada) {
                    $arrayParada = array (
                        "id" => $parada->id,
                        "nom" => $parada->nom,
                        "latitud" => $parada->latitud,
                        "longitud" => $parada->longitud              
                    );
                    array_push($arrayParades, $arrayParada);
                    $i++;                
        }
        
        if (count($arrayParades)>0) {
            $resposta=$arrayParades;            
        } else {
            $resposta=array(
                "status" => "ERROR",
                "missatge" => "No s'han trobat parades"
            );
        }
        return $resposta;
    } else return array(
        "status" => "ERROR",
        "missatge" => "No s'han trobat parades"
    );
}


?>