<?php

include_once '../objects/linia.php';
include_once '../objects/parada.php';
include_once '../objects/expedicio.php';

class Avis {
    //connexió a la base de dades
    private $conn;

     // propietats de l'objecte
     public $id;
     public $tipusObjecte;
     public $objecte;
     public $tipusAvis;
     public $titol;
     public $text;
     public $dataInici;
     public $dataFinal;


    //Constructor amb la connexió a la base de dades
    public function __construct($db){
        $this->conn = $db;
    }

    // funcio readOne
        // carrega informació d'un avis concret
        public function obteDades(){
            $query = "SELECT * FROM Avis A            
                        JOIN TipusAvis B ON A.tipusAvis = B.id
                    WHERE
                        A.id = $this->id
                   ";
            $stmt = $this->conn->prepare( $query );
            $stmt->execute();

            $row = $stmt->fetch(PDO::FETCH_ASSOC);
            
            $this->tipusAvis=$row['nom'];
            $this->titol=$row['titol'];
            $this->text=$row['text'];
            $this->dataInici = ($row['dataInici']!=null ? date("Y-m-d", strtotime($row['dataInici'])) : null);
            $this->dataFinal = ($row['dataFinal']!=null ? date("Y-m-d", strtotime($row['dataFinal'])) : null);
            $this->tipusObjecte=$row['tipusObjecte'];

            switch ($this->tipusObjecte) { //Segons el tipus d'objecte en creem un o altre
                case "parada":
                    $this->objecte = new Parada($this->conn);
                    $this->objecte ->id = $row['idObjecte'];
                    break;
                case "linia":
                    $this->objecte  = new Linia($this->conn);
                    $this->objecte ->codi = $row['idObjecte'];
                    break;
                case "expedicio":
                    $this->objecte  = new Expedicio($this->conn);
                    $this->objecte->id = $row['idObjecte'];
                    break;
                default: break;
            }

            !is_null($this->tipusObjecte) && $this->objecte->obteDades(); //Com que tots els objectes tenen el mateix mètode, el podem cridar des d'aquí
            
        }

        public function obteDadesSenseObjecte(){
            $query = "SELECT * FROM Avis A            
                        JOIN TipusAvis B ON A.tipusAvis = B.id
                    WHERE
                        A.id = $this->id
                   ";
            $stmt = $this->conn->prepare( $query );
            $stmt->execute();

            $row = $stmt->fetch(PDO::FETCH_ASSOC);
            
            $this->tipusAvis=$row['nom'];
            $this->titol=$row['titol'];
            $this->text=$row['text'];
            $this->dataInici = ($row['dataInici']!=null ? date("Y-m-d", strtotime($row['dataInici'])) : null);
            $this->dataFinal = ($row['dataFinal']!=null ? date("Y-m-d", strtotime($row['dataFinal'])) : null);
            $this->tipusObjecte=null;
            
        }

         // retorna Array amb avisos d'un objecte concret
        public function obteAvisosPerObjecte($tipusObjecte, $idObjecte){
            $data=date("Y-m-d"); //Agafa data del dia d'avui, només carreguem els avisos que no han caducat (<dataFinal)            
            $query = "SELECT * FROM Avis A            
                    WHERE
                        A.idObjecte = $idObjecte
                    AND A.tipusObjecte = '$tipusObjecte'
                    AND (A.dataFinal>='$data' OR A.dataFinal IS NULL)
                    ORDER BY A.dataFinal
                   ";
            $stmt = $this->conn->prepare( $query );
            $stmt->execute();
            $arrayAvisos=array();

            //Desmuntem les dades rebudes i les assignem a les diferents caselles de l'array
            while ($row = $stmt->fetch(PDO::FETCH_ASSOC)){
                $avis = new Avis($this->conn); //Crea un objecte Avis per a cada resposta
                $avis->id = $row["id"];
                $avis->obteDades(); 
                array_push($arrayAvisos, $avis);
            }
            return $arrayAvisos;            
        }

        // retorna Array amb tots els avisos
        public function obteTotsAvisos(){
            $data=date("Y-m-d"); //Agafa data del dia d'avui, només carreguem els avisos que no han caducat (<dataFinal)            
            $query = "SELECT * FROM Avis A            
                    WHERE (A.dataFinal>='$data' OR A.dataFinal IS NULL)
                    AND A.tipusObjecte!='expedicio'
                    ORDER BY A.dataFinal
                   ";
            $stmt = $this->conn->prepare( $query );
            $stmt->execute();
            $arrayAvisos=array();

            //Desmuntem les dades rebudes i les assignem a les diferents caselles de l'array
            while ($row = $stmt->fetch(PDO::FETCH_ASSOC)){
                $avis = new Avis($this->conn); //Crea un objecte Avis per a cada resposta
                $avis->id = $row["id"];
                $avis->obteDades(); 
                array_push($arrayAvisos, $avis);
            }
            return $arrayAvisos;            
        }

}

?>