<?php
// Capçaleres per tal que funcioni l'API
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: access");
header("Access-Control-Allow-Methods: GET");
header("Access-Control-Allow-Credentials: true");
header('Content-Type: application/json');
 
// Agafa l'objecte que genera l'API i les dades de la BD
include_once '../config/database.php';
include_once '../objects/avis.php';


// Prepara la connexió a la base de dades
$database = new Database();
$db = $database->getConnection();

// crea un nou objecte
$avis = new Avis($db);


// Agafa l'ID de la linia i els resultats sol·licitats a partir del rebut a través del GET (.php?id=...)
$avis->id = isset($_GET['id']) ? $_GET['id'] : 0;

// Crida la funció de l'objecte
$avis->obteDades();

if($avis->titol!=null){


    //Obtenim dades de la parada concreta
    $resposta=array();
    // Fem una array per emmagatzemar les dades rebudes
    $avis_item = array(
        "id" => $avis->id,
        "titol" => $avis->titol,
        "text" => $avis->text,
        "tipusAvis" => $avis->tipusAvis,
        "dataInici" => $avis->dataInici,
        "dataFinal" => $avis->dataFinal,
        "tipusObjecte" => $avis->tipusObjecte,
        "objecte" => $avis->objecte
 
    );
    
    //Posem l'array generada dins d'un altre array
    $resposta["detalls_avis"] = $avis_item;

    // Si ha funcionat bé, enviarem el codi 200 (OK) i codifiquem la sortida en JSON
    http_response_code(200);
    $resposta["status"] = "OK";
    echo json_encode($resposta);
}
 
else{
    // Si no ha anat bé retorna un missatge d'error
    http_response_code(200);
    echo json_encode(array("status"=>"ERROR", "message" => "No existeix aquest avis."));
}




?>