<?php
// Capçaleres per tal que funcioni l'API
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: access");
header("Access-Control-Allow-Methods: GET");
header("Access-Control-Allow-Credentials: true");
header('Content-Type: application/json');
 
// Agafa l'objecte que genera l'API i les dades de la BD
include_once '../config/database.php';
include_once '../objects/avis.php';


// Prepara la connexió a la base de dades
$database = new Database();
$db = $database->getConnection();

// crea un nou objecte
$avis = new Avis($db);


// Agafa l'ID de la linia i els resultats sol·licitats a partir del rebut a través del GET (.php?id=...)
$tipusObjecte= isset($_GET['objecte']) ? $_GET['objecte'] : 0;
$idObjecte = isset($_GET['id']) ? $_GET['id'] : 0;

// Crida la funció de l'objecte
$arrayAvisos=$avis->obteTotsAvisos();

if(count($arrayAvisos)>0){
    $arrayRespostaAvisos=array();
    foreach ($arrayAvisos as $avis) {
        $respostaAvis = array (
            "id" => $avis->id,
            "titol" => $avis->titol, 
            "text" => $avis->text,            
            "tipusAvis" => $avis->tipusAvis,
            "dataInici" => $avis->dataInici,
            "dataFinal" => $avis->dataFinal,
            "tipusObjecte" => $avis->tipusObjecte,
            "objecte" => $avis->objecte
        );
        array_push($arrayRespostaAvisos, $respostaAvis);

    }

    //Posem l'array generada dins d'un altre array
    $resposta["avisos"] = $arrayRespostaAvisos;

    // Si ha funcionat bé, enviarem el codi 200 (OK) i codifiquem la sortida en JSON
    http_response_code(200);
    $resposta["status"] = "OK";
    echo json_encode($resposta);
}
 
else{
    // Si no ha anat bé retorna un missatge d'error
    http_response_code(200);
    echo json_encode(array("status"=>"ERROR", "message" => "No hi ha avisos vigents en aquests moments"));
}




?>