<?php
// Capçaleres per tal que funcioni l'API
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: access");
header("Access-Control-Allow-Methods: GET");
header("Access-Control-Allow-Credentials: true");
header('Content-Type: application/json');
 
// Agafa l'objecte que genera l'API i les dades de la BD
include_once '../config/database.php';
include_once '../objects/expedicio.php';


// Prepara la connexió a la base de dades
$database = new Database();
$db = $database->getConnection();

// crea un nou objecte
$expedicio = new Expedicio($db);

// Agafa l'ID de la linia i els resultats sol·licitats a partir del rebut a través del GET (.php?id=...)
$expedicio->id = isset($_GET['id']) ? $_GET['id'] : 0;

// Crida la funció de l'objecte
$expedicio->obteDades();

if($expedicio->paradaInici->nom!=null){

    //Obtenim dades de la parada concreta
    $resposta=array();
    // Fem una array per emmagatzemar les dades rebudes
    $expedicio_item = array(
        "id" => $expedicio->id,
        "linia" =>  array(
            "codi" => $expedicio->linia->codi,
            "nom" => $expedicio->linia->nom,
            "sigles" => $expedicio->linia->sigles,
            "color" => $expedicio->linia->color,
            "transport_demanda" => $expedicio->linia->transport_demanda),
        "paradaInici" => array(
            "id" => $expedicio->paradaInici->id,
            "nom" =>  $expedicio->paradaInici->nom,
            "hora" => $expedicio->trobaHoraPas($expedicio->paradaInici)      
        ),
        "paradaFinal" => array(
            "id" => $expedicio->paradaFinal->id,
            "nom" =>  $expedicio->paradaFinal->nom,
            "hora" => $expedicio->trobaHoraPas($expedicio->paradaFinal)           
        ),
        "diesCirculacio" => array(
            "dilluns" => ($expedicio->diesCirculacio[1]==1 ? true : false),
            "dimarts" => ($expedicio->diesCirculacio[2]==1 ? true : false),
            "dimecres" => ($expedicio->diesCirculacio[3]==1 ? true : false),
            "dijous" => ($expedicio->diesCirculacio[4]==1 ? true : false),
            "divendres" => ($expedicio->diesCirculacio[5]==1 ? true : false),
            "dissabte" => ($expedicio->diesCirculacio[6]==1 ? true : false),
            "festiu" => ($expedicio->diesCirculacio[0]==1 ? true : false)
        ),
        "periode" => array(
            "inici" => $expedicio->diaInici,
            "final" => $expedicio->diaFinal
        )
    );
    
    //Posem l'array generada dins d'un altre array
    $resposta["info_expedicio"] = $expedicio_item;

    $arrayHorari = $expedicio->arrayHoraPas();
    $respostaHorari =array();

    foreach ($arrayHorari as $horari) {
        $horariItem = array(
            "parada" => array (
                "id" =>  $horari[0]->id,
                "nom" => $horari[0]->nom,
                "latitud" => $horari[0]->latitud,
                "longitud" => $horari[0]->longitud
            ),
            "horaPas" => $horari[1]
        );
        array_push($respostaHorari, $horariItem);
    }

    $resposta["horari"] = $respostaHorari;

    $resposta["polilinia_codificada"] = $expedicio->obtePolilinia();

    $resposta["avisos"]=$expedicio->obteAvisos();

    // Si ha funcionat bé, enviarem el codi 200 (OK) i codifiquem la sortida en JSON
    http_response_code(200);
    $resposta["status"] = "OK";
    echo json_encode($resposta);
} else {
    // Si no ha anat bé retorna un missatge d'error
    http_response_code(200);
    echo json_encode(array("status"=>"ERROR", "message" => "No existeix aquesta expedició."));
}


?>