<?php
class Parada2{

    // connexio de la base de dades
    private $conn;

   // propietats de l'objecte
    public $id;
    public $nom;
    public $longitud;
    public $latitud;
    public $observacions;
    public $poblacio;
    public $codiPostal;
    public $bergueda;


    //Constructor amb la connexió a la base de dades
    public function __construct($db){
        $this->conn = $db;
    }


    // funció llegir
    // carrega TOTES les parades
    function read(){
         
        $query = "SELECT A.id, A.nom, A.longitud, A.latitud, A.observacions, B.nom AS poblacio, B.codiPostal, B.bergueda FROM Parada A LEFT JOIN Poblacio B ON A.codiPostal = B.codiPostal ORDER BY -A.ordre DESC, id DESC";
        $stmt = $this->conn->prepare($query);
        $stmt->execute();
        return $stmt;
        
    }
    
         // funcio readOne
        // carrega informació d'una parada concreta
        function readOne(){

            $query = "SELECT A.id, A.nom, A.longitud, A.latitud, A.observacions, B.nom AS poblacio, B.codiPostal FROM Parada A LEFT JOIN Poblacio B ON A.codiPostal = B.codiPostal
                    WHERE
                        A.id = ?
                   ";
            $stmt = $this->conn->prepare( $query );
        
            // assignarà el valor de id que rebrà a l'interrogant que em deixat a la consulta.
            $stmt->bindParam(1, $this->id);
            $stmt->execute();
        
            //Desmuntem les dades rebudes i les assignem a les diferents caselles de l'array
            $row = $stmt->fetch(PDO::FETCH_ASSOC);
            
            $this->nom = $row['nom'];
            $this->longitud = $row['longitud'];
            $this->latitud = $row['latitud'];
            $this->observacions = $row['observacions'];
            $this->poblacio = $row['poblacio'];
            $this->codiPostal = $row['codiPostal'];
            
            
        }

}
?>