<?php
// Capçaleres per tal que funcioni l'API
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: access");
header("Access-Control-Allow-Methods: GET");
header("Access-Control-Allow-Credentials: true");
header('Content-Type: application/json');
 
// Agafa l'objecte que genera l'API i les dades de la BD
include_once '../config/database.php';
include_once '../objects/parada2.php';
 
// Prepara la connexió a la base de dades
$database = new Database();
$db = $database->getConnection();
 
// crea un nou objecte
$parada = new Parada2($db);
 
// Agafa l'ID de la parada a partir del rebut a través del GET (.php?id=...)
$parada->id = isset($_GET['id']) ? $_GET['id'] : die();
 
// Crida la funció de l'objecte
$parada->readOne();

if($parada->nom!=null){

    $parada_arr=array();
    $parada_arr["info_parada"]=array();
    // Fem una array per emmagatzemar les dades rebudes
    $parada_item = array(
        "id" =>  $parada->id,
        "nom" => $parada->nom,
        "latitud" => $parada->latitud,
        "longitud" => $parada->longitud,
        "observacions" => $parada->observacions,
        "codiPostal" => $parada->codiPostal,
        "poblacio" => $parada->poblacio
        
 
    );
    
    //Posem l'array generada dins d'un altre array
    array_push($parada_arr["info_parada"], $parada_item);

    // Si ha funcionat bé, enviarem el codi 200 (OK) i codifiquem la sortida en JSON
    http_response_code(200);
    echo json_encode($parada_arr);
}
 
else{
    // Si no ha anat bé retorna el codi 404 i un missatge d'error
    http_response_code(404);
    echo json_encode(array("message" => "No existeix aquesta parada."));
}
?>