import Main from './Components/Main'
import {withRouter} from 'react-router-dom';
import React, { Component } from 'react';
import CacheBuster from './CacheBuster';

//FONT AWESOME
import { library } from '@fortawesome/fontawesome-svg-core'
import { faCheckSquare } from '@fortawesome/pro-solid-svg-icons/faCheckSquare';
import { faCoffee } from '@fortawesome/pro-solid-svg-icons/faCoffee';
import { faSearch } from '@fortawesome/pro-solid-svg-icons/faSearch';
import { faWalking } from '@fortawesome/pro-solid-svg-icons/faWalking';
import { faBus } from '@fortawesome/pro-solid-svg-icons/faBus';
import { faSync } from '@fortawesome/pro-solid-svg-icons/faSync';
import { faCheckCircle } from '@fortawesome/pro-solid-svg-icons/faCheckCircle';
import { faCircle } from '@fortawesome/pro-solid-svg-icons/faCircle';
import { faTimesSquare } from '@fortawesome/pro-solid-svg-icons/faTimesSquare';
import { faTimes } from '@fortawesome/pro-solid-svg-icons/faTimes';
import { faUsers } from '@fortawesome/pro-solid-svg-icons/faUsers';
import { faMapMarkedAlt } from '@fortawesome/pro-solid-svg-icons/faMapMarkedAlt';
import { faArrowRight } from '@fortawesome/pro-solid-svg-icons/faArrowRight';
import { faArrowLeft } from '@fortawesome/pro-solid-svg-icons/faArrowLeft';
import { faPencilAlt } from '@fortawesome/pro-solid-svg-icons/faPencilAlt';
import { faHourglassHalf } from '@fortawesome/pro-solid-svg-icons/faHourglassHalf';
import { faChevronCircleRight } from '@fortawesome/pro-solid-svg-icons/faChevronCircleRight';
import { faExclamationTriangle} from '@fortawesome/pro-solid-svg-icons/faExclamationTriangle';
import { faLayerGroup} from '@fortawesome/pro-solid-svg-icons/faLayerGroup';
import { faCrosshairs} from '@fortawesome/pro-solid-svg-icons/faCrosshairs';

library.add(faCrosshairs, faLayerGroup, faExclamationTriangle, faCheckSquare, faCoffee, faSearch, faChevronCircleRight, faWalking, faSync, faBus, faCheckCircle, faCircle, faTimesSquare, faHourglassHalf, faTimes, faUsers, faMapMarkedAlt, faArrowLeft, faArrowRight, faPencilAlt)

class App extends Component {
    render() {
      return (
        <CacheBuster>
          {({ loading, isLatestVersion, refreshCacheAndReload }) => {
            if (loading) return null;
            if (!loading && !isLatestVersion) {
              refreshCacheAndReload();
            }
  
            return (
              <Main/>
            );
          }}
        </CacheBuster>
      );
    }
  }

export default withRouter(App)
