import React, {Component, Suspense, lazy} from 'react';
import logo from '../logo.svg';
import MapContainer from './MapContainer';
import LlistaParades from './LlistaParades';
import Parada from './Parada'
import {Route} from 'react-router-dom';
import {Link} from 'react-router-dom';
import Alert from 'react-bootstrap/Alert'
import Top from './estructura/Top'
import Portada from './Portada'
import Peu from './estructura/Peu'
import Resultats from './Resultats';
import Mapa from './Mapa';
import Linia from './Linia';
import Expedicio from './Expedicio';
import Administrador from './administrador/Administrador';



class Main extends Component {
  
  constructor(){
    super()
    this.canviOrigen=this.canviOrigen.bind(this)
    this.canviDestinacio=this.canviDestinacio.bind(this)
    this.canviData=this.canviData.bind(this)
    this.canviHora=this.canviHora.bind(this)
    this.assignarItinerari=this.assignarItinerari.bind(this)
    this.mostraMenu=this.mostraMenu.bind(this)
}


state = {
  itinerari: {
    origen:"Origen",
    destinacio:"Destinació",
    data:"08-11-2019",
    hora:"07:00"
  },
  itinerariBuscar: {
    origen:"Origen",
    destinacio:"Destinació",
    data:"08-11-2019",
    hora:"07:00"
  },
  mostraMenu:true
}




//Funcions generació itinerari
canviOrigen(nomParada){
    //Valors que es mantenen  -> STATE
    this.setState({ itinerariBuscar:{origen:nomParada,
      destinacio:this.state.itinerariBuscar.destinacio,
    data:this.state.itinerariBuscar.data,
    hora:this.state.itinerariBuscar.hora}});
}

canviDestinacio(nomParada){
  //Valors que es mantenen  -> STATE
  this.setState({ itinerariBuscar:{origen:this.state.itinerariBuscar.origen,
    destinacio:nomParada,
  data:this.state.itinerariBuscar.data,
  hora:this.state.itinerariBuscar.hora}});
}

canviData(novaData){
  novaData = new Date(novaData);
  var dd = String(novaData.getDate()).padStart(2, '0');
  var mm = String(novaData.getMonth() + 1).padStart(2, '0'); //January is 0!
  var yyyy = novaData.getFullYear();

  var dataFormat = dd + '-' + mm + '-' + yyyy;
  //Valors que es mantenen  -> STATE
  this.setState({ itinerari:{origen:this.state.itinerari.origen,
    destinacio:this.state.itinerari.destinacio,
  data:dataFormat,
  hora:this.state.itinerari.hora}});
  this.setState({ itinerariBuscar:{origen:this.state.itinerariBuscar.origen,
    destinacio:this.state.itinerariBuscar.destinacio,
  data:dataFormat,
  hora:this.state.itinerariBuscar.hora}});
}

canviHora(novaHora){
  novaHora = new Date(novaHora);
  var hh = String(novaHora.getHours()).padStart(2, '0');
  var mm = String(novaHora.getMinutes()).padStart(2, '0'); //January is 0!

  var horaFormat = hh + ':' + mm;
 
  //Valors que es mantenen  -> STATE
  this.setState({ itinerariBuscar:{origen:this.state.itinerariBuscar.origen,
    destinacio:this.state.itinerariBuscar.destinacio,
  data:this.state.itinerariBuscar.data,
  hora:horaFormat}});
  this.setState({ itinerari:{origen:this.state.itinerari.origen,
    destinacio:this.state.itinerari.destinacio,
  data:this.state.itinerari.data,
  hora:horaFormat}});
}

assignarItinerari(){
  this.setState({itinerari:this.state.itinerariBuscar})
  sessionStorage.setItem('itinerari', JSON.stringify(this.state.itinerariBuscar));
}

componentDidMount() {
  //Agafa data d'avui
  var avui = new Date();
 //Assignem els valors actuals a les variables de dia i hora
  
  this.canviData(avui);
  // this.canviHora(avui);

  //Si té valors d'itinerari en memòria, els carrega
  const itinerari = sessionStorage.getItem('itinerari');
        if (itinerari){
          const valors=JSON.parse(itinerari);
          this.setState({itinerari:valors})
        }


}

mostraMenu(valor){
  if (this.state.mostraMenu!=valor) {
      valor ? this.setState({mostraMenu:true}) : this.setState({mostraMenu:false});
  }

}

render() {
  
        
  return (



       <div className="App">
        <Top canviOrigen={this.canviOrigen} canviDestinacio={this.canviDestinacio} canviHora={this.canviHora} canviData={this.canviData} itinerari={this.state.itinerariBuscar} mostraMenu={this.state.mostraMenu} assignarItinerari={this.assignarItinerari}/>
            <Route exact path ="/" render={() => ( <Portada canviOrigen={this.canviOrigen} canviDestinacio={this.canviDestinacio} canviHora={this.canviHora} canviData={this.canviData} itinerari={this.state.itinerariBuscar} assignarItinerari={this.assignarItinerari}/>)}/>
            <Route exact path ="/llistaParades" render={() => ( <LlistaParades/>)}/>
            <Route exact path ="/resultats" render={() => ( <Resultats canviOrigen={this.canviOrigen} canviDestinacio={this.canviDestinacio} canviHora={this.canviHora} canviData={this.canviData} itinerari={this.state.itinerari}  itinerariBuscar={this.state.itinerariBuscar} assignarItinerari={this.assignarItinerari}/>)}/>
            <Route exact path ="/mapa" render={() => (<Mapa/>)}/>
            <Route path={["/parada/:id", "/parada"]} render ={(params) => ( //passem els valors de la URL a través de params
                            <Parada {...params} />    
                        )}/>
            <Route path={["/linia/:id", "/linia"]} render ={(params) => (
                            <Linia {...params} />    
                        )}/>
            <Route path={["/expedicio/:id", "/expedicio"]} render ={(params) => (
                <Expedicio {...params} />    
            )}/>
            
            {/* ADMINISTRADOR */}
            <Route path ="/admin" render={() => (<Administrador componentDidMount={this.mostraMenu(false)} />)}/> 

        <Peu/>


    </div>
  );
} 
}

export default Main;