import React, {Component} from 'react';
import {Card} from 'react-bootstrap';

//Mòdul TargetaAvís
//Props que rep:
// -tipusVora: indica quin estil de vora necessita
//      [primary, secondary, success, danger, warning, info, dark, light]
// -tipus: Indica tipus de l'avis
// -titol: Títol de l'avis
// -descripcio: text amb la descripció de l'avis

class TargetaAvis extends Component {
    
    
    render() {
        let tipusVora = "primary"; //Si no s'ha definit tipus de vora, agafa color per defecte

        if (this.props.tipusVora) {
            tipusVora = this.props.tipusVora
        } 

        return (
              <Card border={tipusVora} style={{ width: '100%' }}>
                <Card.Header>{this.props.tipus}</Card.Header>
                <Card.Body>
                <Card.Title>{this.props.titol}</Card.Title>
                <Card.Text>{this.props.descripcio}</Card.Text>
                </Card.Body>
            </Card>
        )
      }
}

export default TargetaAvis