import React, {Component} from 'react';
import {Button} from 'react-bootstrap';
import {FontAwesomeIcon} from '@fortawesome/react-fontawesome';
import FormulariAvisUsuari from './FormulariAvisUsuari';
import axios from 'axios';

class AvisosUsuari extends Component {

    constructor(){
        super()
        this.canviEstatFinestra=this.canviEstatFinestra.bind(this)
        this.escriuMissatgeTipusAvis=this.escriuMissatgeTipusAvis.bind(this)
        this.obteDades=this.obteDades.bind(this)
      }

    state = {
        finestraOberta: false,
        avisos:null
    }

    canviEstatFinestra() {
        this.state.finestraOberta ? this.setState({finestraOberta:false}) : this.setState({finestraOberta:true});
    }

obteDades() {
    this.setState({generaInterficie: false }); //Abans de carregar dades, posem la careta de Carregant.

    const baseURL = `https://api.mobilitat.ricardcodina.cat/avisUsuari/?idExpedicio=` + this.props.idExpedicio;

    axios.get(baseURL)
    .then(res => {
        if (res.data.status=="OK"){
            const avisos = res.data.llista_avisos
            this.setState({avisos});
        }        
    })
    }    



escriuMissatgeTipusAvis(idTipusAvis, retard, parada) {
    switch (idTipusAvis){
        case "1": return "Retard de " + retard + " minuts al pas per " + parada.nom;
        case "2": return "Bus absent a " + parada.nom;
        case "4": return "Afluència de viatgers a " + parada.nom;
    }
}

componentDidMount() {
    this.obteDades();
  }


render() {

    return (
        <div>
        <div className="modulAvisosUsuari">
            <div className="llistaAvisosUsuari">
                {this.state.avisos &&
                <div>
                    <h5>Incidències assenyalades avui</h5>
                    {this.state.avisos.map((avis,index)=>
                    
                    <div>{avis.hora}: {this.escriuMissatgeTipusAvis(avis.tipusAvis, avis.retard, avis.parada)}</div>
                    
                    )}
                </div>}

            </div>
            <Button variant="secondary" onClick={this.canviEstatFinestra}>Informa d'una incidència</Button>
        </div>

        {this.state.finestraOberta &&
        <div>
            <div className="fonsFinestraFlotant" onClick={this.canviEstatFinestra}></div>
            <div className="finestraFlotant finestraFlotantAvisosUsuari">
                <div className="botoTancar"><FontAwesomeIcon icon="times-square" size="2x" className="maBoto" color="#336122" onClick={this.canviEstatFinestra}/></div>
                <div className="contingutFinestra"><FormulariAvisUsuari parades={this.props.parades} idExpedicio={this.props.idExpedicio} actualitzaLlista={this.obteDades}/></div>

            </div>
        
        </div>
        }
        </div>
    )
}



}

export default AvisosUsuari;