import React, {Component} from 'react';
import {Table} from 'react-bootstrap';
import axios from 'axios';
import { LinkContainer } from "react-router-bootstrap";
import iconaBusBlanca from '../../img/icona-parada-bus-blanca.png'


class TaulaHorari extends Component {
    
    obteDades() {
        this.setState({generaInterficie: false});
        const id = this.props.codiLinia;
        const ordre = this.props.ordre;
        const diaSetmana = this.props.diaSetmana;
        const baseURL = `https://api.mobilitat.ricardcodina.cat/linia/horarisLinia.php?codi=` + id + `&ordre=` + ordre + `&diaSetmana=` + diaSetmana;
    
        axios.get(baseURL)
        .then(res => {
            if (res.data.status=="OK"){
                let dades = res.data.expedicions;
                
                this.setState({dades});
            }
          let missatge = res.data.missatge;
          let status = res.data.status;
          this.setState({status, missatge, generaInterficie: true});
          
        })
      }

    dibuixaFilaHorari(parada, index){
        if (index!=0){
            return(
            <tr>{parada.map((expedicio,index)=><td>{expedicio?expedicio:'-'}</td>)}</tr>
        )
        }

        if (index==0){ //Si rebem la primera línia, conté els codis de les expedicions
            return(
            <tr><td></td>
            {parada.map((expedicio,index)=><LinkContainer to={"/expedicio/"+expedicio}><td className="maBoto"><img
                        src={iconaBusBlanca}
                        width="20"
                        height="20"
                        className="iconaBus"
                        alt="Expedicio"
                    /></td></LinkContainer>)}</tr>
        )
        }
        
        
    }


    state = {
        dades: [{}],
        status:"ERROR",
        generaInterficie: false,
        missatge:''
      }
    
    componentDidUpdate(prevProps) { //Si arriben nous props tornem a executar el mètode de carrega de dades
        if (prevProps.ordre !== this.props.ordre || prevProps.diaSetmana !== this.props.diaSetmana) {
            this.obteDades();
        }
      }

    componentDidMount() {
        this.obteDades();
      }


    render(){
        return(
            
            <div>
                {!this.state.generaInterficie && //Si no ha carregat les dades
                    <div>
                       Carregant...
                    </div>
                }
                
                {this.state.generaInterficie &&
                    <div>
                        {this.state.status=="OK" &&
                            <div>
                        <Table responsive="lg" striped bordered hover variant="dark" className="taulaHorari">
                            <tbody>
                            {this.state.dades.map((parada,index)=>this.dibuixaFilaHorari(parada, index))}
                            </tbody>
                        </Table>
                        </div> } 

                        {this.state.status=="ERROR" &&
                            <div className="missatgeError">
                            <p>{this.state.missatge}</p>
                        </div> } 
                    </div>
                }
            </div>
        )
    }
}

export default TaulaHorari