import React, {Component} from 'react';
import {Map, InfoWindow, Polygon, Polyline, Marker, GoogleApiWrapper} from 'google-maps-react';


const mapStyles = {
  width: '100%',
  height: '300px',
};



export class MapContainerV1 extends Component {

  render() {
    var polyUtil = require('polyline-encoded');
    var encoded = "kz}_GadgJWTU\\INBBJH\\T~@d@rAz@vBfBz@v@h@j@fCtBxAxAFb@";
    var latlngs = polyUtil.decode(encoded);

    var points = [
      { lat: this.props.dades.origen.latitud, lng: this.props.dades.origen.longitud },
      { lat: this.props.dades.destinacio.latitud, lng: this.props.dades.destinacio.longitud }
      ]

      var bounds = new this.props.google.maps.LatLngBounds();
      for (var i = 0; i < points.length; i++) {
        bounds.extend(points[i]);
      }

      //Calculem el centre entre l'origen i la destinació
    var latCenter=((this.props.dades.origen.latitud+this.props.dades.destinacio.latitud)/2)
    var lngCenter=((this.props.dades.origen.longitud+this.props.dades.destinacio.longitud)/2)

    //Convertim a valor de numero les coordenades rebudes
    var latParadaOrigen= Number(this.props.dades.paradaOrigen.latitud)
    var lngParadaOrigen= Number(this.props.dades.paradaOrigen.longitud)
    var latParadaDestinacio=Number(this.props.dades.paradaDestinacio.latitud)
    var lngParadaDestinacio=Number(this.props.dades.paradaDestinacio.longitud)


    //Emmagatzamem les arrays de les Polylinies
    const CoordsPolyLineEntreParades = [
      {lat: latParadaOrigen, lng: lngParadaOrigen},
      {lat: latParadaDestinacio, lng: lngParadaDestinacio},

    ];

    const CoordsPolyLineOrigen = [
      {lat: this.props.dades.origen.latitud, lng: this.props.dades.origen.longitud},
      {lat: latParadaOrigen, lng: lngParadaOrigen},

    ];

    const CoordsPolyLineDestinacio = [
      {lat: latParadaDestinacio, lng: lngParadaDestinacio},
      {lat: this.props.dades.destinacio.latitud, lng: this.props.dades.destinacio.longitud},

    ];




    var itinerariVisible = this.props.itinerariVisible;
    
  
    console.log(CoordsPolyLineDestinacio);

    return (
         <div className="mapa">
        <Map
        google={this.props.google}
        style={mapStyles}
        initialCenter={{ lat: latCenter, lng: lngCenter}}
        zoom={11}
        bounds={bounds}
        
      >
          <Marker
            title={'Origen'}
            name={'SOMA'}
            position={{lat: this.props.dades.origen.latitud, lng: this.props.dades.origen.longitud}}
            
            icon={{
              url: "https://carlisletheacarlisletheatre.org/images/start-icon-4.png",
              anchor: new this.props.google.maps.Point(16,16),
              scaledSize: new this.props.google.maps.Size(32,32)
            }}/>

          <Marker
            title={this.props.dades.paradaOrigen.nom}
            name={'SOMA'}
            position={{lat: this.props.dades.paradaOrigen.latitud, lng: this.props.dades.paradaOrigen.longitud}}
            icon={{
              url: "https://carlisletheacarlisletheatre.org/images/start-icon-4.png",
              anchor: new this.props.google.maps.Point(8,8),
              scaledSize: new this.props.google.maps.Size(16,16)
            }}/>

          <Marker
            title={'Destinació'}
            name={'SOMA'}
            position={{lat: this.props.dades.destinacio.latitud, lng: this.props.dades.destinacio.longitud}}
            icon={{
              url: "https://d29fhpw069ctt2.cloudfront.net/icon/image/39218/preview.png",
              anchor: new this.props.google.maps.Point(16,16),
              scaledSize: new this.props.google.maps.Size(32,32)
            }} />

            <Marker
            title={this.props.dades.paradaDestinacio.nom}
            name={'SOMA'}
            position={{lat: this.props.dades.paradaDestinacio.latitud, lng: this.props.dades.paradaDestinacio.longitud}}
            icon={{
              url: "https://d29fhpw069ctt2.cloudfront.net/icon/image/39218/preview.png",
              anchor: new this.props.google.maps.Point(8,8),
              scaledSize: new this.props.google.maps.Size(16,16)
            }}/>

          <Polygon
          path={CoordsPolyLineEntreParades}
          strokeColor={this.props.itineraris.linia.color}
          strokeOpacity={0.8}
          strokeWeight={4}
          />
  

            
            
            <Polyline
          path={CoordsPolyLineOrigen}
          strokeColor="#000000"
          strokeOpacity={0.8}
          strokeWeight={2} />
          <Polyline
          path={CoordsPolyLineDestinacio}
          strokeColor="#000000"
          strokeOpacity={0.8}
          strokeWeight={2} />
    </Map></div>
    );
  }
}
 
export default GoogleApiWrapper({
  apiKey: (`AIzaSyCYEQJ7nw4waLh4o_IvlQHDCzGVQQvlOOI`)
})(MapContainer)