import React, {Component} from 'react';
import { compose, withProps} from "recompose"
import { withScriptjs, withGoogleMap, GoogleMap, Marker, Polyline } from "react-google-maps"

const MapaGoogle = compose(
    withProps({
      googleMapURL: "https://maps.googleapis.com/maps/api/js?key=AIzaSyCYEQJ7nw4waLh4o_IvlQHDCzGVQQvlOOI&v=3.exp&libraries=geometry,drawing,places",
      loadingElement: <div style={{ height: `100%` }} />,
      containerElement: <div style={{ height: `300px` }} />,
      mapElement: <div style={{ height: `100%` }} />,
    }),
    withScriptjs,
    withGoogleMap
  )((props) =>
  
    <GoogleMap
      defaultZoom={15}
      defaultCenter={{ lat: props.latCenter, lng: props.lngCenter }}
    >
  
  <Marker
              title={'Origen'}
              name={'SOMA'}
              position={{lat: Number(props.dades.origen.latitud), lng: Number(props.dades.origen.longitud)}}
              
              icon={{
                url: "https://carlisletheacarlisletheatre.org/images/start-icon-4.png",
                anchor: new window.google.maps.Point(16,16),
                scaledSize: new window.google.maps.Size(32,32)
              }}/>
  
            <Marker
              title={props.dades.paradaOrigen.nom}
              name={'SOMA'}
              position={{lat: Number(props.dades.paradaOrigen.latitud), lng: Number(props.dades.paradaOrigen.longitud)}}
              icon={{
                url: "https://carlisletheacarlisletheatre.org/images/start-icon-4.png",
                anchor: new window.google.maps.Point(8,8),
                scaledSize: new window.google.maps.Size(16,16)
              }}/>
  
            
  
              {/* Polilinia ruta a peu des d'origen */}
              <Polyline
                        path={props.CoordsPolyLineOrigen}
                        options={{
                          strokeColor:"#000000",
                          strokeOpacity:0.8,
                          strokeWeight:2
                        }}
                        />
    </GoogleMap>
  )


class MapaRecorregutAPeu extends Component {
    render() {
        return (<div>

            </div>
        )
    }

}

export default MapaRecorregutAPeu