import React, {Component} from 'react';
import {Card, Row, Col, OverlayTrigger, Tooltip, Button} from 'react-bootstrap';
import { LinkContainer } from "react-router-bootstrap";
import axios from 'axios';


class ModulLinies extends Component {

//CARREGA LINIES
constructor(){
    super()
    this.obteDades=this.obteDades.bind(this)
  }
  
  
  
  obteDades() {
    this.setState({generaInterficie: false }); //Abans de carregar dades, posem la careta de Carregant.
    const baseURL = `https://api.mobilitat.ricardcodina.cat/linia/`;
  
    axios.get(baseURL)
    .then(res => {
        if (res.data.status=="OK"){
          const linies = res.data.llistat;
          this.setState({linies});
        }        
      const status = res.data.status;
      this.setState({status, generaInterficie: true });  
  
    }) 
  }
  
  
    state = {
        linies:null,
        status:"ERROR",
        generaInterficie: false
      }
  
  
      componentDidMount() {
        this.obteDades();
      }

    render() {

        return (
          <div>
              {this.state.linies &&
                    <Card style={{ width: '100%' }}>
                        <Card.Body>
                            <Card.Title>Línies</Card.Title>
                            <Card.Subtitle className="mb-2 text-muted">Consulta els detalls de les línies que recorren la comarca</Card.Subtitle>
                                <div className="iconesLiniaPortada">{this.state.linies.map((linia, index)=>
                                    <OverlayTrigger
                                    key={"linia"+index}
                                    placement="top"
                                    overlay={
                                        <Tooltip id={`tooltip-${"linia"+index}`}>
                                        {linia.nom}
                                        </Tooltip>
                                    }
                                    >
                                    <LinkContainer to={"/linia/"+linia.codi}><div><div className="siglesLinia maBoto" style={{backgroundColor: linia.color}}>{linia.sigles}</div></div></LinkContainer>
                                    </OverlayTrigger>                       
                               
                                )}
                                                
                            </div>
                            <div><LinkContainer to={"/linia"}><Card.Link>Veure totes</Card.Link></LinkContainer></div>
                            
                        </Card.Body>
                        </Card>
                }
          </div>
        )
      }
}

export default ModulLinies